/*!\file alone.c
 *
 * \brief lock d'application pour qu'elle soit unique
 */

#include "utils.h"

int alone_locked=0;

/*!\brief lock l'application pour qu'elle soit unique
 */
void alone(char *name)
	{
	int fd;
	pid_t pid=getpid();

	if((fd=open(name,O_CREAT|O_EXCL|O_WRONLY,0644))<0)
		{
		perror("Can't open lock file");

		if((fd=open(name,O_RDONLY))>=0)
			{
			char proc[128];
			read(fd,&pid,sizeof(pid_t));
			close(fd);

			fprintf(stderr,"Actual process are pid %d\n",pid);

			sprintf(proc,"/proc/%i/cmdline",pid);
			fprintf(stderr,"test %s\n",proc);

			if(file_exist(proc)==-1)
				{
				fprintf(stderr,"Actual process are death, unlink filelock\n");
				unlink(name);
				if((fd=open(name,O_CREAT|O_EXCL|O_WRONLY,0644))>=0)
					goto ok;
				}
			}
		exit(1);
		}
ok:
	write(fd,&pid,sizeof(pid_t));
	close(fd);
	alone_locked=1;
	}

